<?php
class ControllerShippingTNT extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('shipping/tnt');

		$this->document->title = $this->language->get('heading_title');

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('tnt', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/shipping');
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		$this->data['text_letter'] = $this->language->get('text_letter');
		$this->data['text_standard_parcels'] = $this->language->get('text_standard_parcels');
		$this->data['text_extra_parcels'] = $this->language->get('text_extra_parcels');
		$this->data['text_extra_parcels_return'] = $this->language->get('text_extra_parcels_return');
		$this->data['text_eec_parcels'] = $this->language->get('text_eec_parcels');
		$this->data['text_rest_of_world'] = $this->language->get('text_rest_of_world');
		$this->data['entry_service'] = $this->language->get('entry_service');
		$this->data['entry_display_weight'] = $this->language->get('entry_display_weight');
		$this->data['entry_display_insurance'] = $this->language->get('entry_display_insurance');
		$this->data['entry_display_time'] = $this->language->get('entry_display_time');
		$this->data['entry_weight_class'] = $this->language->get('entry_weight_class');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home',
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/shipping',
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=shipping/tnt',
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = HTTPS_SERVER . 'index.php?route=shipping/tnt';

		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/shipping';

		if (isset($this->request->post['tnt_letter'])) {
			$this->data['tnt_letter'] = $this->request->post['tnt_letter'];
		} else {
			$this->data['tnt_letter'] = $this->config->get('tnt_letter');
		}

		if (isset($this->request->post['tnt_standard_parcels'])) {
			$this->data['tnt_standard_parcels'] = $this->request->post['tnt_standard_parcels'];
		} else {
			$this->data['tnt_standard_parcels'] = $this->config->get('tnt_standard_parcels');
		}

		if (isset($this->request->post['tnt_extra_parcels'])) {
			$this->data['tnt_extra_parcels'] = $this->request->post['tnt_extra_parcels'];
		} else {
			$this->data['tnt_extra_parcels'] = $this->config->get('tnt_extra_parcels');
		}

		if (isset($this->request->post['tnt_extra_parcels_return'])) {
			$this->data['tnt_extra_parcels_return'] = $this->request->post['tnt_extra_parcels_return'];
		} else {
			$this->data['tnt_extra_parcels_return'] = $this->config->get('tnt_extra_parcels_return');
		}

		if (isset($this->request->post['tnt_eec_parcels'])) {
			$this->data['tnt_eec_parcels'] = $this->request->post['tnt_eec_parcels'];
		} else {
			$this->data['tnt_eec_parcels'] = $this->config->get('tnt_eec_parcels');
		}

		if (isset($this->request->post['tnt_rest_of_world'])) {
			$this->data['tnt_rest_of_world'] = $this->request->post['tnt_rest_of_world'];
		} else {
			$this->data['tnt_rest_of_world'] = $this->config->get('tnt_rest_of_world');
		}

		if (isset($this->request->post['tnt_display_weight'])) {
			$this->data['tnt_display_weight'] = $this->request->post['tnt_display_weight'];
		} else {
			$this->data['tnt_display_weight'] = $this->config->get('tnt_display_weight');
		}

		if (isset($this->request->post['tnt_display_insurance'])) {
			$this->data['tnt_display_insurance'] = $this->request->post['tnt_display_insurance'];
		} else {
			$this->data['tnt_display_insurance'] = $this->config->get('tnt_display_insurance');
		}

		if (isset($this->request->post['tnt_display_time'])) {
			$this->data['tnt_display_time'] = $this->request->post['tnt_display_time'];
		} else {
			$this->data['tnt_display_time'] = $this->config->get('tnt_display_time');
		}

		if (isset($this->request->post['tnt_weight_class'])) {
			$this->data['tnt_weight_class'] = $this->request->post['tnt_weight_class'];
		} else {
			$this->data['tnt_weight_class'] = $this->config->get('tnt_weight_class');
		}

		$this->load->model('localisation/weight_class');

		$this->data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();

		if (isset($this->request->post['tnt_tax_class_id'])) {
			$this->data['tnt_tax_class_id'] = $this->request->post['tnt_tax_class_id'];
		} else {
			$this->data['tnt_tax_class_id'] = $this->config->get('tnt_tax_class_id');
		}

		if (isset($this->request->post['tnt_geo_zone_id'])) {
			$this->data['tnt_geo_zone_id'] = $this->request->post['tnt_geo_zone_id'];
		} else {
			$this->data['tnt_geo_zone_id'] = $this->config->get('tnt_geo_zone_id');
		}

		if (isset($this->request->post['tnt_status'])) {
			$this->data['tnt_status'] = $this->request->post['tnt_status'];
		} else {
			$this->data['tnt_status'] = $this->config->get('tnt_status');
		}

		if (isset($this->request->post['tnt_sort_order'])) {
			$this->data['tnt_sort_order'] = $this->request->post['tnt_sort_order'];
		} else {
			$this->data['tnt_sort_order'] = $this->config->get('tnt_sort_order');
		}

		$this->load->model('localisation/tax_class');

		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		$this->template = 'shipping/tnt.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/tnt')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}
?>