<?php
/**
 * Opencart 1.4.7 TNT Post module
 * @version $Id$ = 1.4.7 rc 1
 * 2010
 */
class ModelShippingTNT extends Model {
	function getQuote($address) {
		$this->load->language('shipping/tnt');

		if ($this->config->get('tnt_status')) {
      		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('tnt_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

      		if (!$this->config->get('tnt_geo_zone_id')) {
        		$status = TRUE;
      		} elseif ($query->num_rows) {
        		$status = TRUE;
      		} else {
        		$status = FALSE;
      		}
		} else {
			$status = FALSE;
		}


		$quote_data = array();


		if ($status) {
			$weight = $this->cart->getWeight();
			$sub_total = $this->cart->getSubTotal();


			// Brievenpost
			if ($this->config->get('tnt_letter') && $address['iso_code_2'] == 'NL') {
				$cost = 0;

				$rates = array();

				$rates = explode(',', '.02:.3697,.05:.7394,.100:1.1092,.250:1.4789,.500:1.8457'); //kilogram:prijs

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}


				if ((float)$cost) {
					$title = $this->language->get('text_letter');

					if ($this->config->get('tnt_display_weight')) {
						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}

					$quote_data['letter'] = array(
						'id'           => 'tnt.letter',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}


			// pakket post
			if ($this->config->get('tnt_standard_parcels') && $address['iso_code_2'] == 'NL') {
				$cost = 0;
				$compensation = 0;

				$rates = explode(',', '.500:0,10:5.6722,30:10.8823'); //gewicht tot 500 gram is brievenpost

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = explode(',', '10:0,30:50');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {

					$title = $this->language->get('text_standard_parcels');

					if ($this->config->get('tnt_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($compensation > 0) {

						if ($this->config->get('tnt_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
						}
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_three');
					}

					$quote_data['standard_parcels'] = array(
						'id'           => 'tnt.standard_parcels',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// pakket post extra zeker
			if ($this->config->get('tnt_extra_parcels') && $address['iso_code_2'] == 'NL') {
				$cost = 0;
				$compensation = 0;


				$rates = explode(',', '0.5:0,5:5.8823,10:7.1428');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = explode(',', '10:50');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {

					$title = $this->language->get('text_extra_parcels');

					if ($this->config->get('tnt_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_three');
					}

					$quote_data['extra_parcels'] = array(
						'id'           => 'tnt.extra_parcels',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// pakket post met handtekening retour
			if ($this->config->get('tnt_extra_parcels_return') && $address['iso_code_2'] == 'NL') {
				$cost = 0;
				$compensation = 0;

				$rates = explode(',', '0.5:0,5:6.8487,10:8.1092');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = explode(',', '10:50');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {

					$title = $this->language->get('text_extra_parcels_return');

					if ($this->config->get('tnt_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_three');
					}

					$quote_data['extra_parcels_return'] = array(
						'id'           => 'tnt.extra_parcels_return',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// pakketpost EU

			if ($this->config->get('tnt_eec_parcels')) {
				$cost = 0;
				$compensation = 0;
				$rates = array();

				// EU1
				$countries = explode(',', 'AT,BE,DK,ES,FI,FR,GB,DE,IT,LU,SE');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '0.5:5.2100,2:11.0084,5:16.3865,10:21.1764,20:28.6554');
				}
				// EU2
				$countries = explode(',', 'BG,EE,FI,HU,IE,LT,LV,PL,PT,RO,SI,SK,CZ');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '0.5:5.2100,2:15.7983,5:20.5882,10:25.8823,20:32.9411');
				}

				// Hier zijn Cyprus, Griekenland en Malta aan toegevoegd met het tarief van ROW 1 ivm btw
				// EU3
				$countries = explode(',', 'CY,GR,MT');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:15.798319,5:21.008403,10:26.218487,20:34.705883');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = array();

				$countries = explode(',', 'AT,BE,DK,ES,FI,FR,GB,DE,IT,LU,SE');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:500,5:500,10:500,20:500');
				}

				$countries = explode(',', 'BG,EE,FI,HU,IE,LT,LV,PL,PO,RO,SI,SK,CZ');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:500,5:500,10:500,20:500');
				}

				$countries = explode(',', 'CY,GR,MT');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:146,5:146,10:146,20:146');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {
					$title = $this->language->get('text_eec_parcels');

					if ($this->config->get('tnt_display_weight')) {
						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_five');
					}

					$quote_data['eec_parcels'] = array(
						'id'           => 'tnt.eec_parcels',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// internationaal pakket post ROW1 en ROW2
			// voor deze landen is de verzending btw vrij.
			if ($this->config->get('tnt_rest_of_world')) {
				$cost = 0;
				$compensation = 0;

				$rates = array();
				// ROW 1
				$countries = explode(',', 'AL,AD,BY,BA,HR,FO,GI,GL,GG,IS,IM,JE,LI,MK,MD,ME,NO,SM,RS,CH,TR,UA,VA');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:18.80,5:25.00,10:31.20,20:41.30');
				}
				// ROW 2
				$countries = explode(',', 'AF,AX,DZ,AS,AO,AI,AQ,AG,AR,AM,AW,AZ,BS,BH,BD,BB,BZ,BJ,BM,BT,BO,BW,BV,BR,IO,BN,BF,BI,
										   KH,CM,CA,CV,KY,CF,TD,CL,CN,CX,CC,CO,KM,CG,CD,CK,CR,CI,CU,DJ,DM,DO,EC,EG,SV,GQ,ER,ET,
										   FK,FJ,GF,PF,TF,GA,GM,GE,GH,GD,GP,GU,GT,GN,GW,GY,HT,HM,HN,HK,IN,ID,IR,IQ,IL,JM,JP,JO,
										   KZ,KE,KI,KP,KR,KW,KG,LA,LB,LS,LR,LY,MO,MG,MW,MY,MV,ML,MH,MQ,MR,MU,YT,MX,FM,MN,MS,MA,
										   MZ,MM,NA,NR,NP,AN,NC,NZ,NI,NE,NG,NU,NF,MP,OM,PK,PW,PS,PA,PG,PY,PE,PH,PN,PR,QA,RE,RU,
										   RW,BL,SH,KN,LC,MF,PM,VC,WS,ST,SA,SN,SC,SL,SG,SB,SO,ZA,GS,LK,SD,SR,SJ,SZ,SY,TW,TJ,TZ,
										   TH,TL,TG,TK,TO,TT,TN,TM,TC,TV,UG,AE,US,UM,UY,UZ,VU,VE,VN,VG,VI,WF,EH,YE,ZM,ZW');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:24.10,5:34.20,10:57.20,20:104.10');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = array();

				$countries = explode(',', 'AL,AD,BY,BA,HR,FO,GI,GL,GG,IS,IM,JE,LI,MK,MD,ME,NO,SM,RS,CH,TR,UA,VA');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:146,5:146,10:146,20:146');
				}

				$countries = explode(',', 'AF,AX,DZ,AS,AO,AI,AQ,AG,AR,AM,AW,AZ,BS,BH,BD,BB,BZ,BJ,BM,BT,BO,BW,BV,BR,IO,BN,BF,BI,
										   KH,CM,CA,CV,KY,CF,TD,CL,CN,CX,CC,CO,KM,CG,CD,CK,CR,CI,CU,DJ,DM,DO,EC,EG,SV,GQ,ER,ET,
										   FK,FJ,GF,PF,TF,GA,GM,GE,GH,GD,GP,GU,GT,GN,GW,GY,HT,HM,HN,HK,IN,ID,IR,IQ,IL,JM,JP,JO,
										   KZ,KE,KI,KP,KR,KW,KG,LA,LB,LS,LR,LY,MO,MG,MW,MY,MV,ML,MH,MQ,MR,MU,YT,MX,FM,MN,MS,MA,
										   MZ,MM,NA,NR,NP,AN,NC,NZ,NI,NE,NG,NU,NF,MP,OM,PK,PW,PS,PA,PG,PY,PE,PH,PN,PR,QA,RE,RU,
										   RW,BL,SH,KN,LC,MF,PM,VC,WS,ST,SA,SN,SC,SL,SG,SB,SO,ZA,GS,LK,SD,SR,SJ,SZ,SY,TW,TJ,TZ,
										   TH,TL,TG,TK,TO,TT,TN,TM,TC,TV,UG,AE,US,UM,UY,UZ,VU,VE,VN,VG,VI,WF,EH,YE,ZM,ZW');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '2:146,5:146,10:146,20:146');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {
					$title = $this->language->get('text_rest_of_world');

					if ($this->config->get('tnt_display_weight')) {
						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_display_time')) {
						$title .= $this->language->get('text_eta_ten');
					}

					$quote_data['rest_of_world'] = array(
						'id'           => 'tnt.rest_of_world',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

		}

		$method_data = array();

		if ($quote_data) {
			$method_data = array(
				'id'         => 'tnt',
				'title'      => $this->language->get('text_title'),
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('tnt_sort_order'),
				'error'      => FALSE
			);
		}

		return $method_data;
	}
}
?>